/********************************************************************************
 * Copyright (c) 2021-2024 Bayerische Motoren Werke Aktiengesellschaft (BMW AG)
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 ********************************************************************************/

#pragma once

#include "Utils/EntityBroker.h"

{% for include in node.includes %}
#include {{ include }}
{% endfor %}

{% block includes_special %}{% endblock %}

namespace {{ ose_namespace }}
{

class {{ name }}Base
{
  public:
    struct Values
    {
        {% block implementation_values_special %}{% endblock %}
        Entities entities;
        {% for var in node.values %}
        {{var.declaration}};
        {% endfor %}
    };
    struct Interfaces
    {
        {% for var in node.blackboard_getter %}
        {{var.type}} {{util.local(var)}};
        {% endfor %}
    };

    {{ name }}Base(Values values, Interfaces interfaces) :
        values{std::move(values)},
        mantle{std::move(interfaces)}
    {};

    virtual ~{{ name }}Base() = default;
    virtual void SetControlStrategy() = 0;
    [[nodiscard]] virtual bool HasControlStrategyGoalBeenReached(const std::string& actor) = 0;
    [[nodiscard]] virtual mantle_api::MovementDomain GetMovementDomain() const = 0;

  protected:
    Values values;
    Interfaces mantle;
};

}
